import java.text.NumberFormat;

/** Ad un oggetto cassiere viene indicata una somma ricevuta e una somma da
    pagare. L'oggetto indica come dare il resto con il numero minimo di monete.
*/
public class Cassiere  {
  /** Specifica il totale dovuto */
  public void setTotaleSpesa(double tot) {
    totaleSpesa = tot;
  }

  /** Specifica la somma ricevuta */
  public void setSommaRicevuta(double somma) {
    sommaRicevuta = somma;
  }

  /** Stampa sullo standard output la ripartizione del resto in banconote e
        monete */
  public void dimmiMonete() {
    // Definisco un formattatore per stampare i valori monetari
    NumberFormat formatter = NumberFormat.getNumberInstance();
    formatter.setMaximumFractionDigits(2);
    formatter.setMinimumFractionDigits(2);
    //Calcolo del resto in virgola mobile
    double resto = sommaRicevuta - totaleSpesa;
    //Controllo di resto positivo
    if ( resto < 0 ) {
      System.out.println("Somma ricevuta insufficiente");
      return;
    }
    // C'e' un resto
    System.out.println("Somma ricevuta = " + formatter.format(sommaRicevuta));
    System.out.println("Somma dovuta   = " + formatter.format(totaleSpesa))
      ;
    System.out.println("Resto dovuto   = " + formatter.format(resto));
    // Parte intera = numero di dollari
    int dollari = (int)resto;
    double decimaliDelResto = resto - dollari;
    // Calcolo il numero totale di penny
    int totalePennies = (int)Math.round(decimaliDelResto * PENNIES_PER_DOLLAR
      );
    System.out.println("(" + dollari + " dollari e " +
      totalePennies + " centesimi)");
    System.out.println("Dollari interi: " + dollari);
    // Divisione intera per trovare il max numero di quarters
    int numeroQuarters = totalePennies / PENNIES_PER_QUARTER;
    System.out.println("Numero di quarters: " + numeroQuarters);
    // Calcolo dei penny rimasti
    totalePennies = totalePennies % PENNIES_PER_QUARTER;
    // Divisione intera per trovare il max numero di dimes
    int numeroDimes = totalePennies / PENNIES_PER_DIME;
    System.out.println("Numero di dimes: " + numeroDimes);
    // Penny rimasti
    totalePennies = totalePennies % PENNIES_PER_DIME;
    // Stessa cosa per nickel
    int numeroNickels = totalePennies / PENNIES_PER_NICKEL;
    System.out.println("Numero di nickels: " + numeroNickels);
    totalePennies = totalePennies % PENNIES_PER_NICKEL;
    // Stampa i penny che rimangono
    System.out.println("Numero di pennies: " + totalePennies);
  }

  // variabili istanza
  private double totaleSpesa, sommaRicevuta;

  // Costanti pubbliche
  /** Valore in penny di un dollaro */
  public static final int PENNIES_PER_DOLLAR = 100;

  /** Valore in penny di un nickel */
  public static final int PENNIES_PER_NICKEL = 5;

  /** Valore in penny di un dime */
  public static final int PENNIES_PER_DIME = 10;

  /** Valore in penny di un quarter */
  public static final int PENNIES_PER_QUARTER = 25;
}
