/** Una classe che descrive gli effetti di un terremoto 
   */
public class Earthquake {
  /** Costruisce un oggetto che rappresenta un terremoto 
      @param magnitude la magnitudo nella scala Richter */
  public Earthquake(double magnitude) {
    richter = magnitude;
  }
  /** Restituisce una descrizione degli effetti del terremoto
      @return la descrizione dell'effetto */
  public String getDescription() {
  String r;
  // Esempio di if a cascata
  if (richter >= 8.0)
    r = "Quasi la totalit delle strutture sono cadute";
  else if (richter >= 7.0) // tra 7.0 e 8.0 (8.0 non compreso)
    r = "Molti edifici distrutti";
  else if (richter >= 6.0) // 6.0 <= richter < 7.0
    r = "Molti edifici seriamente danneggiati e alcuni collassati";
  else if (richter >= 4.5) // continua come sopra
    r = "Danni a edifici poco resistenti";
  else if (richter >= 3.5) 
    r = "Sentito da molte persone, non distruttivo";
  else if (richter >= 0)
    r = "Generalmente non avvertito dalle persone";
  else // richter < 0
    r = "Magnitudo negativa non valida";
  return r;
  }
  // Variabile istanza per memorizzare la magnitudo
  private double richter;
}
